'use strict';

// process.stdout.isTTY
var form = require('terminal-forms.js').create(process.stdin, process.stdout);
var OAUTH3 = require('../oauth3.node.js');
OAUTH3.hooks.directives._get = require('../oauth3.node.storage.js').directives._get;
OAUTH3.hooks.directives._set = require('../oauth3.node.storage.js').directives._set;
var url = require('url');
console.log('stdin tty', process.stdin.isTTY);
console.log('stdout tty', process.stdout.isTTY);

form.ask({ label: "What's your OAuth3 Provider URL? ", type: 'url' }).then(function (urlResult) {
  var urlObj = url.parse(urlResult.input);
  // TODO get unique client id for bootstrapping app
  var oauth3 = OAUTH3.create(urlObj);
  var providerPromise = oauth3.setProvider(urlObj.host + urlObj.pathname);

  function getCurrentUserEmail() {
    return form.ask({ label: "What's your email (or cloud mail) address? ", type: 'email' }).then(function (emailResult) {
      // TODO lookup uuid locally before performing loginMeta
      // TODO lookup token locally before performing loginMeta / otp
      return providerPromise.then(function () {
        return OAUTH3.authn.loginMeta(oauth3._providerDirectives, { email: emailResult.input }).then(function (result) {
          // TODO require hashcash to create user account
          console.log(result);
          return form.PromiseA.reject(new Error("not implemented"));
        });
      });
    });
  }

  getCurrentUserEmail().then(function (email) {
    // TODO skip if token exists locally
    return OAUTH3.authn.otp(oauth3._providerDirectives, { email: email }).then(function (otpResult) {
      return form.ask({
        label: "What's your login code?"
      , help: "(it was sent to '" + urlResult.input + "' and looks like 1234-5678-9012)"
      }).then(function () {
        console.log(otpResult);
      });
    });
  });
});
